//+------------------------------------------------------------------+
//|                                               Ind-Fractals-1.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Aqua
#property indicator_color2 Aqua
//---- input parameters
extern int      TimePeriod=0;
extern string TimePeriodExpl="Minutes - 0=Current";
extern bool      Comm=true;
//---- buffers
double HighFractal[];
double LowFractal[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID,2);
   SetIndexArrow(0,217);
   SetIndexBuffer(0,HighFractal);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID,2);
   SetIndexArrow(1,218);
   SetIndexBuffer(1,LowFractal);
   SetIndexEmptyValue(1,0.0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//------------------------------------------------------------------  
/*bool Fractal (string F,int Per, int shift)
  {
   if (Period()>Per) return(-1);
   if (shift>Bars-Per)return(-1); 
      if (F=="U")
        {
         if (High[shift+2]>High[shift])return(-1);
         if (High[shift+1]>High[shift])return(-1);
         if (High[shift-1]>=High[shift])return(-1);     
        }
      if (F=="L")
        {
         if (Low[shift+2]<Low[shift])return(-1);
         if (Low[shift+2]<Low[shift])return(-1);
         if (Low[shift-1]<=Low[shift])return(-1);
        }        
   return(1);   
  }  */
//----------------New Improved Fractal Routine--------------------------------------------------  
bool Fractal (string F,int TF, int shift)
{
int barsback, barsforward, TFbarsback, TFbarsforward, M, i;
int Per = Period();
datetime barbegin = Time[shift];
int monthdays[12] = {31,28,31,30,31,30,31,31,30,31,30,31}; 
  
if(TF == 0) TF = Period();
if (Period()>TF) return(false);

int dom = TimeDay(barbegin);
int dow = TimeDayOfWeek(barbegin);
int hour = TimeHour(barbegin);
int min = TimeMinute(barbegin);
int month = TimeMonth(barbegin);

switch(TF)
   {
   case 1:
   case 5:
   case 15:
   case 30:
   case 60:
      TFbarsback = MathMod(min,TF)/Per;
      TFbarsforward = TF/Per - TFbarsback -1;
      barsback = TF/Per*2+TFbarsback;
      barsforward = TF/Per*2+TFbarsforward;
      break;
   case 240:
   case 1440:
      M = hour*60+min;
      TFbarsback = MathMod(M,TF)/Per;
      TFbarsforward = TF/Per - barsback -1;
      if(dow>=3)
         barsback = TF/Per*2+TFbarsback;
      else
         barsback = TF/Per+TFbarsback;
      if(dow<=3)
         barsforward = TF/Per*2+TFbarsforward;
      else
         barsforward = TF/Per+TFbarsforward;
      break;
   case 10080:
      M = dow*1440+hour*60+min;
      TFbarsback = MathMod(M,TF)/Per;
      TFbarsforward = 8640/Per - barsback -1;     // don't include saturdays
      barsback = TF/Per*2+TFbarsback;
      barsforward = TF/Per*2+TFbarsforward;
      break;
   case 43200:
      int daysback = dom - MathCeil((dom-dow-1)/7);   // Cancel out saturdays
      int totaldays = monthdays[month] - MathFloor((monthdays[month]-dom-dow-1)/7) + daysback;   // Cancel out saturdays
      M = daysback*1440+hour*60+min;
      TFbarsback = MathMod(M,TF)/Per;
      TFbarsforward = totaldays*1440/Per - barsback -1;
      barsback = TF/Per*2+TFbarsback;
      barsforward = TF/Per*2+TFbarsforward;
      break;
   default:
      Print(" Invalid Timeframe");
      return(false);
      break;
   }


if (shift<barsforward)return(false);
if (shift>Bars-barsback)return(false); 

for (i=1;i<=barsback;i++)
  {
   if (F=="U")
     {
     if (High[shift+i]>High[shift])return(false);
     }
   if (F=="L")
     {
     if (Low[shift+i]<Low[shift])return(false);
     }        
  }
for (i=1;i<=barsforward;i++)
  {
   if (F=="U")
     {
     if (High[shift-i]>=High[shift])return(false);
     }
   if (F=="L")
     {
     if (Low[shift-i]<=Low[shift])return(false);
     }        
  }
return(true);   
}  
/*//----------------Real (unmodified) Fractal Routine--------------------------------------------------  
bool Fractal (string F,int Per, int shift)
  {
   if (Period()>Per) return(-1);
   Per=Per/Period()*2+MathCeil(Per/Period()/2);
   if (shift<Per)return(-1);
   if (shift>Bars-Per)return(-1); 
   for (int i=1;i<=Per;i++)
     {
      if (F=="U")
        {
         if (High[shift+i]>High[shift])return(-1);
         if (High[shift-i]>=High[shift])return(-1);     
        }
      if (F=="L")
        {
         if (Low[shift+i]<Low[shift])return(-1);
         if (Low[shift-i]<=Low[shift])return(-1);
        }        
     }
   return(1);   
  }*/  
//------------------------------------------------------------------
int start()
  {
   int D1=1440, H4=240, H1=60, M15=15,B;
   double P;
//   int    counted_bars=IndicatorCounted();
   B=Bars;
   if(TimePeriod == 0 || TimePeriod<Period()) TimePeriod = Period();
   
   if (Period()==D1)P=150*Point;   // Set distance away from high or low to plot arrow
   if (Period()==H4)P=70*Point;
   if (Period()==H1)P=40*Point;
   if (Period()==30)P=30*Point;
   if (Period()==M15)P=20*Point;
   if (Period()==5)P=10*Point;
   if (Period()==1)P=5*Point;   
   for (int shift=B;shift>0;shift--)
      {
      HighFractal[shift] = 0;
      LowFractal[shift] = 0;
//   Print("Fractal Upper i= ",shift,"  ",iFractals(NULL, TimePeriod, MODE_UPPER, shift));   
//   Print("Fractal Lower i= ",shift,"  ",iFractals(NULL, TimePeriod, MODE_LOWER, shift));   
//      if (iFractals(NULL, TimePeriod, MODE_UPPER, shift)>0 ) HighFractal[shift]=High[shift]+P;  // For current period only
//      if (iFractals(NULL, TimePeriod, MODE_LOWER, shift)>0 ) LowFractal[shift]=Low[shift]-P;

//      if (Fractal("U",5,shift)==1 || Fractal("U",15,shift)==1 || Fractal("U",60,shift)==1 || Fractal("U",240,shift)==1 || Fractal("U",1440,shift)==1) HighFractal[shift]=High[shift]+P;
//      if (Fractal("L",5,shift)==1 || Fractal("L",15,shift)==1 || Fractal("L",60,shift)==1 || Fractal("L",240,shift)==1 || Fractal("L",1440,shift)==1) LowFractal[shift]=Low[shift]-P;
      if (Fractal("U",TimePeriod,shift)==true ) HighFractal[shift]=High[shift]+3*P;  // For current period only
      if (Fractal("L",TimePeriod,shift)==true ) LowFractal[shift]=Low[shift]-3*P;
      }
//   if (Comm) Comment(" D1 - brown\n H4 - green\n H1 - blue\nM15 - red ");
 //  ObjectCreate("T_D1",OBJ_TEXT,0,Time[30],Close[0]+10*P);
 //  ObjectSetText("T_D1","D1",10,"Times New Roman",indicator_color8);
 //  ObjectCreate("T_H4",OBJ_TEXT,0,Time[20],Close[0]+10*P);
 //  ObjectSetText("T_H4","H4",10,"Times New Roman",indicator_color6);
 //  ObjectCreate("T_H1",OBJ_TEXT,0,Time[10],Close[0]+10*P);
 //  ObjectSetText("T_H1","H1",10,"Times New Roman",indicator_color4);
 //  ObjectCreate("T_M15",OBJ_TEXT,0,Time[0],Close[0]+10*P);
 //  ObjectSetText("T_M15","M15",10,"Times New Roman",indicator_color2);
   return(0);
  }
//+------------------------------------------------------------------+